//-------------------------------------------------------------------
//!JNXwb_
//!@memo 08/07/18 mmm
//-------------------------------------------------------------------

#ifndef __MMM_CAMEAR_H__
#define __MMM_CAMEAR_H__

#include "MMMStd.h"

namespace mmm
{
	//-------------------------------------------------------------------
	//!JNX
	//!@memo@Œ̃f[^Ɗ֐JNX
	//-------------------------------------------------------------------
	class CameraBase
	{
	public:
		CameraBase();
		~CameraBase(){}
	public:
		const Vector3& GetPos(){ return pos_; }
		const Vector3& GetAt(){ return at_; }
		const Vector3& GetUp(){ return up_; }
		void SetPos(const Vector3& pos){ pos_ = pos; }
		void SetAt(const Vector3& at){ at_ = at; }
		void SetUp(const Vector3& up){ up_ = up; }
	public:
		void SetProjectionParams(float fov, float aspect, float zn, float zf)
		{
			fov_ = fov;
			aspect_ = aspect;
			zn_ = zn;
			zf_ = zf;
		}
		void GetProjectionParams(float* fov, float* aspect, float* zn, float* zf)
		{
			if(fov) *fov = fov_;
			if(aspect) *aspect = aspect_;
			if(zn) *zn = zn_;
			if(zf) *zf = zf_;
		}
	public:
		//!sAxNg̍XV֐
		void Setting()
		{
			view_ = at_ - pos_;
			view_.Normalize();
			D3DXMatrixLookAtLH(&matView_.ToD3D(), &pos_.ToD3D(), &at_.ToD3D(), &up_.ToD3D());
			D3DXMatrixPerspectiveFovLH(&matProj_.ToD3D(), fov_, aspect_, zn_, zf_);
		}
	public:
		const Vector3& GetViewVector() const { return view_; }
		const Matrix& GetViewMatrix() const { return matView_; }
		const Matrix& GetProjectionMatrix() const { return matProj_; }
	private:
		Vector3 pos_;		//!<ʒu
		Vector3 at_;		//!<_
		Vector3 up_;		//!<
		Vector3 view_;		//!<xNg
		Matrix matView_;	//!<r[s
		Matrix matProj_;	//!<vWFNVs
		float fov_;			//!<p
		float aspect_;		//!<AXyNg
		float zn_;			//!<߃Nbvy
		float zf_;			//!<Nbvy
	};
}

#endif
