//-------------------------------------------------------------------
//!sNX\[X
//!@memo 08/07/18 mmm
//-------------------------------------------------------------------

#include "MMMMath.h"

#ifdef MMM_USE_D3DX
#include <d3dx9.h>
#endif

using namespace mmm;

//-----------------------------------------------------------
//!Pʍs
//-----------------------------------------------------------
const Matrix Matrix::E(	1.f, 0, 0, 0,
						0, 1.f, 0, 0,
						0, 0, 1.f, 0,
						0, 0, 0, 1.f);

//-----------------------------------------------------------
//RXgN^
//-----------------------------------------------------------
Matrix::Matrix(	float _11, float _12, float _13, float _14,
				float _21, float _22, float _23, float _24,
				float _31, float _32, float _33, float _34,
				float _41, float _42, float _43, float _44)
:
	_11(_11), _12(_12), _13(_13), _14(_14),
	_21(_21), _22(_22), _23(_23), _24(_24),
	_31(_31), _32(_32), _33(_33), _34(_34),
	_41(_41), _42(_42), _43(_43), _44(_44)
{
}
Matrix::Matrix(const Matrix& rhs)
:
	_11(rhs._11), _12(rhs._12), _13(rhs._13), _14(rhs._14),
	_21(rhs._21), _22(rhs._22), _23(rhs._23), _24(rhs._24),
	_31(rhs._31), _32(rhs._32), _33(rhs._33), _34(rhs._34),
	_41(rhs._41), _42(rhs._42), _43(rhs._43), _44(rhs._44)
{
}
//-----------------------------------------------------------
//!Zq
//-----------------------------------------------------------
Matrix Matrix::operator = (const Matrix& rhs)
{
	memcpy(m_, rhs.m_, sizeof(float) * COUNT);
	return *this;
}
//-----------------------------------------------------------
//!Zq̒`p}N
//-----------------------------------------------------------
#define DECLARE(ope)															\
Matrix Matrix::operator ope (const Matrix& rhs) const							\
{																				\
	return Matrix																\
	(																			\
		_11 ope rhs._11, _12 ope rhs._12, _13 ope rhs._13, _14 ope rhs._14,	\
		_21 ope rhs._21, _22 ope rhs._22, _23 ope rhs._23, _24 ope rhs._24,	\
		_31 ope rhs._31, _32 ope rhs._32, _33 ope rhs._33, _34 ope rhs._34,	\
		_41 ope rhs._41, _42 ope rhs._42, _43 ope rhs._43, _44 ope rhs._44		\
	);																			\
}
DECLARE(+);
DECLARE(-);

//-----------------------------------------------------------
//!s̊|Z
//-----------------------------------------------------------
Matrix Matrix::operator * (const Matrix& rhs) const
{
	return Matrix
	(
		_11 * rhs._11 + _12 * rhs._21 + _13 * rhs._31 + _14 * rhs._41,
		_11 * rhs._12 + _12 * rhs._22 + _13 * rhs._32 + _14 * rhs._42,
		_11 * rhs._13 + _12 * rhs._23 + _13 * rhs._33 + _14 * rhs._43,
		_11 * rhs._14 + _12 * rhs._24 + _13 * rhs._34 + _14 * rhs._44,

		_21 * rhs._11 + _22 * rhs._21 + _23 * rhs._31 + _24 * rhs._41,
		_21 * rhs._12 + _22 * rhs._22 + _23 * rhs._32 + _24 * rhs._42,
		_21 * rhs._13 + _22 * rhs._23 + _23 * rhs._33 + _24 * rhs._43,
		_21 * rhs._14 + _22 * rhs._24 + _23 * rhs._34 + _24 * rhs._44,

		_31 * rhs._11 + _32 * rhs._21 + _33 * rhs._31 + _34 * rhs._41,
		_31 * rhs._12 + _32 * rhs._22 + _33 * rhs._32 + _34 * rhs._42,
		_31 * rhs._13 + _32 * rhs._23 + _33 * rhs._33 + _34 * rhs._43,
		_31 * rhs._14 + _32 * rhs._24 + _33 * rhs._34 + _34 * rhs._44,

		_41 * rhs._11 + _42 * rhs._21 + _43 * rhs._31 + _44 * rhs._41,
		_41 * rhs._12 + _42 * rhs._22 + _43 * rhs._32 + _44 * rhs._42,
		_41 * rhs._13 + _42 * rhs._23 + _43 * rhs._33 + _44 * rhs._43,
		_41 * rhs._14 + _42 * rhs._24 + _43 * rhs._34 + _44 * rhs._44
	);
}

#undef DECLARE
//-----------------------------------------------------------
//!Zq̒`}N
//-----------------------------------------------------------
#define DECLARE(ope)														\
Matrix& Matrix::operator ope (const Matrix& rhs)							\
{																			\
	_11 ope rhs._11; _12 ope rhs._12; _13 ope rhs._13, _14 ope rhs._14;	\
	_21 ope rhs._21; _22 ope rhs._22; _23 ope rhs._23; _24 ope rhs._24;	\
	_31 ope rhs._31; _32 ope rhs._32; _33 ope rhs._33; _34 ope rhs._34;	\
	_41 ope rhs._41; _42 ope rhs._42; _43 ope rhs._43; _44 ope rhs._44;	\
	return *this;															\
}
DECLARE(+=);
DECLARE(-=);
Matrix& Matrix::operator *=(const Matrix& rhs)
{
	Matrix mat(*this);
	(*this = mat * rhs);
	return *this;
}

#undef DECLARE

Matrix Matrix::operator * (float s) const
{
	return Matrix
	(
		_11 * s, _12 * s, _13 * s, _14 * s,
		_21 * s, _22 * s, _23 * s, _24 * s,
		_31 * s, _32 * s, _33 * s, _34 * s,
		_41 * s, _42 * s, _43 * s, _44 * s
	);
}
Matrix Matrix::operator / (float s) const
{
	s = 1.f / s;
	return Matrix
	(
		_11 * s, _12 * s, _13 * s, _14 * s,
		_21 * s, _22 * s, _23 * s, _24 * s,
		_31 * s, _32 * s, _33 * s, _34 * s,
		_41 * s, _42 * s, _43 * s, _44 * s
	);
}
//-----------------------------------------------------------
//!{
//-----------------------------------------------------------
Matrix& Matrix::operator *=(float s)
{
	Matrix mat(*this);
	(*this = mat * s);
	return *this;
}
Matrix& Matrix::operator /=(float s)
{
	Matrix mat(*this);
	(*this = mat * s);
	return *this;
}
//-----------------------------------------------------------
//!esxNgɒlݒ肷֐
//-----------------------------------------------------------
void Matrix::SetVector(int i, const Vector3& v)
{
	m_[i][0] = v.x_;
	m_[i][1] = v.y_;
	m_[i][2] = v.z_;
	m_[i][3] = 1.f;
}
//-----------------------------------------------------------
//!tsݒ֐
//-----------------------------------------------------------
Matrix* InverseMatrix(Matrix* pOut, const Matrix& src)
{
	return (Matrix*)D3DXMatrixInverse((D3DXMATRIX*)pOut, 0, (D3DXMATRIX*)&src);
}
//-----------------------------------------------------------
//!Pʍsɐݒ肷֐
//-----------------------------------------------------------
void Matrix::Identity()
{
	memcpy(m_, Matrix::E.m_, sizeof(Matrix));
}
//-----------------------------------------------------------
//!gksݒ֐
//-----------------------------------------------------------
Matrix* Matrix::Scaling(const Vector3& v)
{
	Identity();

	_11 = v.X();
	_22 = v.Y();
	_33 = v.Z();
	_44 = 1.f;

	return this;
}
//-----------------------------------------------------------
//!x]sݒ֐
//!@memo
//!		cos(r)  0  -sin(r)  0 
//!		0		1	0		0
//!		sin(r)	0   cos(r)  0 
//!		0		0	0		1
//-----------------------------------------------------------
Matrix* Matrix::RotationYaw(float rad)
{
	return (Matrix*)D3DXMatrixRotationY((D3DXMATRIX*)this, rad);
#if 0
	Identity();

	float c = cosf(rad);
	float s = sinf(rad);
	_11 = _33 = c;
	_13 = -s;
	_31 = s;

	return this;
#endif
}
//-----------------------------------------------------------
//!w]sݒ֐
//!@memo
//!		1	0		0		0 
//!		0	cos(r)	sin(r)  0
//!		0	-sin(r) cos(r)  0
//!		0	0		0		1
//-----------------------------------------------------------
Matrix* Matrix::RotationPitch(float rad)
{
#ifdef MMM_USE_D3DX
	return (Matrix*)D3DXMatrixRotationX((D3DXMATRIX*)this, rad);
#else
	Identity();

	float c = cosf(rad);
	float s = sinf(rad);
	_22 = _33 = c;
	_23 = s;
	_32 = -s;

	return this;
#endif
}
//-----------------------------------------------------------
//!y]sݒ֐
//!@memo
//!		cos(r)	sin(r)	0	0 
//!		-sin(r)	cos(r)	0	0
//!		0		0		1	0 
//!		0		0		0	1
//-----------------------------------------------------------
Matrix* Matrix::RotationRoll(float rad)
{
#ifdef MMM_USE_D3DX
	return (Matrix*)D3DXMatrixRotationZ((D3DXMATRIX*)this, rad);
#else
	Identity();

	float c = cosf(rad);
	float s = sinf(rad);
	_11 = _22 = c;
	_12 = s;
	_21 = -s;

	return this;
#endif
}
//-----------------------------------------------------------
//!]sݒ֐
//-----------------------------------------------------------
Matrix* Matrix::Rotation(const Vector3& r)
{
	Identity();
	Matrix mR;
	mR.RotationYaw(r.Y());		*this *= mR;
	mR.RotationPitch(r.X());	*this *= mR;
	mR.RotationRoll(r.Z());		*this *= mR;

	return this;
}
//-----------------------------------------------------------
//!sړsݒ֐
//!@note
//!		1 0 0 0
//!		0 1 0 0
//!		0 0 1 0
//!		x y z 1
//-----------------------------------------------------------
Matrix* Matrix::Translation(const Vector3& v)
{
	Identity();

	_41 = v.X();
	_42 = v.Y();
	_43 = v.Z();

	return this;
}
//-----------------------------------------------------------
//!sړsݒ֐
//!@note
//!		1 0 0 0
//!		0 1 0 0
//!		0 0 1 0
//!		x y z 1
//-----------------------------------------------------------
Matrix* Matrix::Translation(float x, float y, float z)
{
	Identity();

	_41 = x;
	_42 = y;
	_43 = z;

	return this;
}
//-----------------------------------------------------------
//!sړNAs̐ݒ֐
//-----------------------------------------------------------
Matrix* CutTranslate(Matrix* pOut)
{
	pOut->_41 = pOut->_42 = pOut->_43 = 0.f;
	return pOut;
}
//-----------------------------------------------------------
//!sɕsړݒ肷֐
//-----------------------------------------------------------
Matrix* SetTranslate(Matrix* pOut, const Vector3& v)
{
	pOut->_41 = v.x_;
	pOut->_42 = v.y_;
	pOut->_43 = v.z_;

	return pOut;
}
//-----------------------------------------------------------
//!s̐ݒ֐
//-----------------------------------------------------------
Matrix* Zero(Matrix* pOut)
{
	memset(pOut->m_, 0, sizeof(float) * Matrix::COUNT);

	return pOut;
}
//-----------------------------------------------------------
//![hϊs߂֐
//-----------------------------------------------------------
Matrix* WorldMatrix(Matrix* pOut, const Vector3& scale, const Vector3& rotate, const Vector3& trans)
{
	Matrix mS, mR, mT;
	mS.Scaling(scale);
	mR.Rotation(rotate);
	mT.Translation(trans);

	*pOut = mS * mR * mT;

	return pOut;
}
//-----------------------------------------------------------
//!XP[Õ[hϊs߂֐
//-----------------------------------------------------------
Matrix* WorldMatrix(Matrix* pOut, const Vector3& rotate, const Vector3& trans)
{
	Matrix mR, mT;
	mR.Rotation(rotate);
	mT.Translation(trans);

	*pOut = mR * mT;

	return pOut;
}
//-----------------------------------------------------------
//!r[ϊs߂֐
//-----------------------------------------------------------
Matrix* ViewMatrix(Matrix* out, const Vector3& from, const Vector3& at, const Vector3& wup)
{
	Vector3 view(at - from);
	view.Normalize();

	float dot = Dot(wup, view);
	Vector3 up;
	up.x_ = wup.x_ - dot * view.x_;
	up.y_ = wup.y_ - dot * view.y_;
	up.z_ = wup.z_ - dot * view.z_;
	
	up.Normalize();
	
	Vector3 right;
	Cross(&right, up, view);

	out->_11 = right.x_; out->_12 = up.x_; out->_13 = view.x_; out->_14 = 0.f;
	out->_21 = right.y_; out->_22 = up.y_; out->_23 = view.y_; out->_24 = 0.f;
	out->_31 = right.z_; out->_32 = up.z_; out->_33 = view.z_; out->_34 = 0.f;

	out->_41 = -Dot(from, right);
	out->_42 = -Dot(from, up);
	out->_43 = -Dot(from, view);
	out->_44 = 1.0f;

	return out;
}
//-----------------------------------------------------------
//!ˉeϊs߂֐
//-----------------------------------------------------------
Matrix* ProjectionMatrix(Matrix* out, float nearClip, float farClip, float fov, float aspect)
{
	float fovHalf = fov * 0.5f;
	float ratio = cosf(fovHalf) / sinf(fovHalf);
	float w = aspect * ratio;
	float h = 1.0f * ratio;
	float q = farClip / (farClip - nearClip);

	out->Identity();

	out->_11 = w;
	out->_22 = h;
	out->_33 = q;
	out->_34 = 1.f;
	out->_43 = - nearClip * q;
	out->_44 = 0.f;

	return out;
}
//-----------------------------------------------------------
//!r[|[gs߂֐
//-----------------------------------------------------------
Matrix* ViewportMatrix(Matrix* out, float x, float y, float width, float height, float minZ, float maxZ)
{
	float wh = width * 0.5f;
	float hh = height * 0.5f;
	float rangeZ = maxZ - minZ;

	out->_11 = wh;		out->_12 = 0.f;		out->_13 = 0.f;		out->_14 = 0.f;
	out->_21 = 0.f;		out->_22 = - hh;	out->_23 = 0.f;		out->_24 = 0.f;
	out->_31 = 0.f;		out->_32 = 0.f;		out->_33 = rangeZ;	out->_34 = 0.f;
	out->_41 = x + wh;	out->_42 = y + hh;	out->_43 = minZ;	out->_44 = 1.f;

	return out;
}
//-----------------------------------------------------------
//exNg̎擾֐
//-----------------------------------------------------------
Vector3* GetVectorX(Vector3* pOut, const Matrix& m){ pOut->Set(m._11, m._12, m._13); return pOut; }
Vector3* GetVectorY(Vector3* pOut, const Matrix& m){ pOut->Set(m._21, m._22, m._23); return pOut; }
Vector3* GetVectorZ(Vector3* pOut, const Matrix& m){ pOut->Set(m._31, m._32, m._33); return pOut; }
//-----------------------------------------------------------
//SĂ̎xNg̎擾֐
//-----------------------------------------------------------
void GetVectorXYZ(Vector3 outs[3], const Matrix& m)
{
	outs[0].Set(m._11, m._12, m._13);
	outs[1].Set(m._21, m._22, m._23);
	outs[2].Set(m._31, m._32, m._33);
}
//-----------------------------------------------------------
//!esxNg̎擾֐
//-----------------------------------------------------------
Vector3* GetVectorColmun(Vector3* pOut, const Matrix& m, int colID)
{
	pOut->Set(m.m_[colID][0], m.m_[colID][1], m.m_[colID][2]);
	return pOut;
}
//-----------------------------------------------------------
//!esxNg̐ݒ֐
//-----------------------------------------------------------
Matrix* SetVectorColmun(Matrix* pOut, const Vector3& v, int colID)
{
	pOut->m_[colID][0] = v.x_;
	pOut->m_[colID][1] = v.y_;
	pOut->m_[colID][2] = v.z_;
	return pOut;
}
//-----------------------------------------------------------
//!sړ̃xNg̎擾֐
//-----------------------------------------------------------
Vector3* GetTranslate(Vector3* pOut, const Matrix& m)
{
	pOut->Set(m._41, m._42, m._43);
	return pOut;
}
