//-------------------------------------------------------------------
//!DirectX`̃NXւ̂܂Ƃ߃Tv\[X
//!@memo 08/07/24 mmm
//-------------------------------------------------------------------

//-------------------------------------------------------------------
#include "MMMAWindow.h"
#include "MMMAAppBase.h"
#include "MMMMath.h"
#include "MMMCamera.h"
#include "MMMGraphic.h"
#include "MMMVertex.h"

using namespace mmm;

//-------------------------------------------------------------------
#define	WINDOW_TITLE	"eXgEBhE"	//!<^Cg
#define	SCREEN_WIDTH	640					//!<
#define	SCREEN_HEIGHT	480					//!<c

//-------------------------------------------------------------------
//!CEBhENX
//-------------------------------------------------------------------
class MainWindow : public mmm::AWindow
{
public:
	MainWindow()
	{
		//TODO:ŃX^CȂǂݒ
		SetStyle(WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX);
		SetStyleEx(0);
		SetRegisterName("TEST");
	}
	virtual ~MainWindow(){}
private:
	virtual LRESULT	CALLBACK MyProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		//TODO:ł̃NXp̃vV[W`
		switch(msg)
		{
		case WM_DESTROY: PostQuitMessage(0); break;
		default: return AWindow::MyDefProc(hWnd, msg, wParam, lParam); break;
		};

		return	FALSE;
	}
};

//-------------------------------------------------------------------
//!eXgp̃AvP[VNX
//-------------------------------------------------------------------
class TestApp : public mmm::AAppBase
{
public:
	TestApp(){}
	virtual ~TestApp(){}
private:
	virtual bool Init()
	{
		//CEBhE
		if(CreateMyWindow(&mainWnd_, SCREEN_WIDTH, SCREEN_HEIGHT, WINDOW_TITLE) == false) return false;
		if(graphic_.Create(mainWnd_.GetHandle(), SCREEN_WIDTH, SCREEN_HEIGHT) == false) return false;
		if(dbgFont_.Create(&graphic_, 0, 18, 0, "lr ") == false) return false;

		LPDIRECT3DDEVICE9 pDev = graphic_.GetDevice();
		if(GetVertexDecManager().CreateDeclareVertexTypes(pDev) == false) return false;

		if(geoBuf_.CreateVertex(pDev, 3, mmm::VERTEX_TYPE_3DBASE, 0) == false) return false;

		//_obt@փf[^ݒ
		Vertex3D verts[] =
		{
			{ Vector3(-1.0f,-1.0f, 0.0f), Vector3(0.f, 0.f, 1.f) },
			{ Vector3(1.0f,-1.0f, 0.0f), Vector3(0.f, 0.f, 1.f) },
			{ Vector3(0.0f, 1.0f, 0.0f), Vector3(0.f, 0.f, 1.f) },
		};
		VertexColor vertColors[] =
		{
			{ 0xff000000, },
			{ 0xff000000, },
			{ 0xffffffff, },
		};
		geoBuf_.SetVertex3D(verts);
		geoBuf_.SetVertexColor(vertColors);

		//J̏ݒ
		camera_.SetPos(Vector3(0.f, 0.f, V2M(-5.f)));
		camera_.SetAt(Vector3(0.f, 0.f, 0.f));
		camera_.SetProjectionParams(D3DX_PI / 4.f, 1.f, V2M(1.f), V2M(10.f));
		camera_.Setting();

		return true;
	}
	virtual int Update()
	{
		//IʒmĂI
		if(IsQuit()) return UPDATE_EXIT;
		if(mainWnd_.IsActive() == false) return UPDATE_PAUSE;

		//`揈s
		Render();

		return UPDATE_RUN;
	}
	virtual bool Release()
	{
		if(geoBuf_.Release() == false) return false;
		if(GetVertexDecManager().ReleaseDeclareVertexTypes() == false) return false;
		if(dbgFont_.Release() == false) return false;
		if(graphic_.Release() == false) return false;

		return true;
	}
	//!`֐
	void Render()
	{
		if(graphic_.IsCreated() == false) return;

		graphic_.Clear(mmm::Graphic::CLEAR_IMAGE | mmm::Graphic::CLEAR_Z, mmm::Graphic::ColorRGB(64, 64, 64), 1.f);

		//`Jn̐錾
		if(graphic_.BeginScene())
		{
			dbgFont_.DrawText(0, 0, mmm::DebugFont::ALIGN_RIGHT, mmm::Graphic::ColorRGB(255, 96, 96), "hello world version 4.");

			LPDIRECT3DDEVICE9 pDev = graphic_.GetDevice();

			//ϊs̐ݒ
			D3DXMATRIX matWorld;
			D3DXMatrixRotationY(&matWorld, timeGetTime() / 150.0f);
			pDev->SetTransform(D3DTS_WORLD, &matWorld);
			pDev->SetTransform(D3DTS_VIEW, &camera_.GetViewMatrix().ToD3D());
			pDev->SetTransform(D3DTS_PROJECTION, &camera_.GetProjectionMatrix().ToD3D());

			//`p̐ݒ
			pDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);
			pDev->SetRenderState(D3DRS_LIGHTING, FALSE);

			geoBuf_.SettingRenderSource();

			//`
			pDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 1);
		}
		//`I̐錾
		graphic_.EndScene();

		graphic_.Present();
	}
private:
	mmm::CameraBase camera_;		//!<J
	mmm::Graphic graphic_;			//!<OtBbN
	mmm::DebugFont dbgFont_;		//!<fobOtHg
	mmm::GeometryBuffer geoBuf_;	//!<WIgobt@

	MainWindow mainWnd_;		//!<CEBhE
};
//-------------------------------------------------------------------
//!Windows ProgrammingɂĈԍŏɌĂ΂֐
//-------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmdLine, int nCmdShow)
{
	hPrevInst;
	lpszCmdLine;
	nCmdShow;

	int exit = 0;
	{
		TestApp app;
		app.Run(hInst);
		exit = app.GetExitCode();
	}

	return exit;
}
